package me.km.snuviscript;

import me.hammerle.snuviscript.code.ISnuviLogger;
import me.hammerle.snuviscript.code.Script;
import me.km.KajetansMod;
import me.km.api.Module;

public class SnuviLogger implements ISnuviLogger
{
    @Override
    public void print(String message, Exception ex, String function, String scriptname, Script sc, int line) 
    {
        if(KajetansMod.debugMode || (sc != null && sc.isStackTracePrinted()))
        {
            Module m = KajetansMod.scripts;
            if(scriptname != null)
            {
                m.sendWarningToConsole("error in '" + scriptname + "'");
            }
            if(message != null)
            {
                m.sendHelpListElementToConsole("message", message);
            }
            if(ex != null)
            {
                m.sendHelpListElementToConsole("exception", ex.getClass().getSimpleName());
            }
            if(function != null)
            {
                m.sendHelpListElementToConsole("function", function);
            }
            if(line != -1)
            {
                m.sendHelpListElementToConsole("Zeile", String.valueOf(line));
            }
        }
        
        // TODO - chat channels
        KajetansMod.server.getPlayerList().getPlayers().forEach(p -> 
        {
            Module m = KajetansMod.scripts;
            if(scriptname != null)
            {
                m.sendWarning(p, "error in '" + scriptname + "'");
            }
            if(message != null)
            {
                m.sendHelpListElement(p, "message", message);
            }
            if(ex != null)
            {
                m.sendHelpListElement(p, "exception", ex.getClass().getSimpleName());
            }
            if(function != null)
            {
                m.sendHelpListElement(p, "function", function);
            }
            if(line != -1)
            {
                m.sendHelpListElement(p, "Zeile", String.valueOf(line));
            }
        });
    }
}
